VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "HP33120"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Member0" ,"Class1"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
' **********************************************************************************
' ClassWork 1.0 (1999) Vincent Himpe All rights reserved
'                      Released under OpenSource Policy
'
' ClassBook Library for HP33120 Function Generator
' Initial release
' **********************************************************************************
Dim v_address  ' internal address handler

Enum v_waveform
    Sine = 1
    Triangle = 2
    Square = 3
    Ramp = 4
    DC = 5
    Noise = 6
    Pulse = 7
End Enum
Enum v_impedance
    Minimum = 1
    Maximum = 2
    Infinite = 3
    Term50 = 4
End Enum


Public Sub Class_Initialize()
   logentry "'Classwork spawned a HP33210 instrument"
End Sub

Public Sub impedance(impedance As v_impedance)
   Select Case impedance
   Case Minimum
       GPIBwrite v_address, "OUTP:LOAD MIN"
   Case Maximum
       GPIBwrite v_address, "OUTP:LOAD MAX"
   Case Infinite
       GPIBwrite v_address, "OUTP:LOAD INF"
   Case Else
       GPIBwrite v_address, "OUTP:LOAD 50"
   End Select
End Sub

Public Property Let Frequency(Frequency)
    GPIBwrite v_address, "SOUR:FREQ " + Str$(Frequency)
End Property
Public Property Let amplitude(amplitude)
    GPIBwrite v_address, "SOUR:VOLT " + Str$(amplitude)
End Property
Public Property Let offset(offset)
    GPIBwrite v_address, "SOUR:VOLT:OFFS " + Str$(offset)
End Property

Private Sub i_Sine()
    GPIBwrite v_address, "SOUR:FUNC:SHAP SIN"
End Sub
Private Sub i_Ramp()
    GPIBwrite v_address, "SOUR:FUNC:SHAP RAMP"
End Sub
Private Sub i_Triangle()
    GPIBwrite v_address, "SOUR:FUNC:SHAP TRI"
End Sub
Private Sub i_Square()
    GPIBwrite v_address, "SOUR:FUNC:SHAP SQU"
End Sub
Private Sub i_Noise()
    GPIBwrite v_address, "SOUR:FUNC:SHAP NOIS"
End Sub
Private Sub i_DC()
    GPIBwrite v_address, "SOUR:FUNC:SHAP DC"
End Sub
Private Sub i_Pulse()
    GPIBwrite v_address, "SOUR:FUNC:SHAP PULS"
End Sub

Public Sub waveform(wave As v_waveform)
  
  Select Case wave
    Case Sine
        i_Sine
    Case Square
        i_Square
    Case Triangle
        i_Triangle
    Case Ramp
    Case DC
    Case Noise
    Case Pulse
         i_Pulse
  End Select
  
End Sub
Public Sub PDCycle(duty_cycle)
    GPIBwrite v_address, "SOUR:PULS:DCYC" + Str$(duty_cycle)
End Sub
Public Sub TriggerNOW()
    GPIBwrite v_address, "*TRG"
    GPIBwrite v_address, "*WAI"
End Sub
Public Sub TriggerInt()
    GPIBwrite v_address, "TRIGGER:SOURCE int"
End Sub
Public Sub TriggerBus()
    GPIBwrite v_address, "TRIGGER:SOURCE bus"
End Sub
Public Sub TriggerExt()
    GPIBwrite v_address, "TRIGGER:SOURCE EXT"
End Sub
Public Sub Arb()
    GPIBwrite v_address, "FUNC:USER VOLATILE"
    GPIBwrite v_address, "FUNC:SHAP USER"
End Sub

Public Sub LoadArb(wavefile As String)
    Dim filehandle
    Dim cmd$
    Dim a$
    On Error GoTo skipfile
    filehandle = FreeFile
    cmd$ = "DATA VOLATILE"
    Open wavefile For Input As filehandle
    While Not EOF(filehandle)
       Line Input #1, a$
       cmd$ = cmd$ + "," + Trim$(a$)
    Wend
    GPIBwrite v_address, cmd$
skipfile:
    Close filehandle
End Sub
Public Sub sweep(startfreq, stopfreq, sweeptime, linlog)
    GPIBwrite v_address, "SOUR:FREQ:STAR " + Str$(startfreq)
    GPIBwrite v_address, "SOUR:FREQ:STOP " + Str$(stopfreq)
    GPIBwrite v_address, "SOUR:SWE:TIME " + Str$(sweeptime)
    If linlog = 0 Then
       GPIBwrite v_address, "SOUR:SWE:SPAC LIN"
    Else
       GPIBwrite v_address, "SOUR:SWE:SPAC LOG"
    End If
End Sub
Public Sub StartSweep()
    GPIBwrite v_address, "SOUR:SWE:STAT ON"
End Sub
Public Sub StopSweep()
    GPIBwrite v_address, "SOUR:SWE:STAT OFF"
End Sub
Public Sub trig(Trigger As String)
     Select Case Trigger
        Case "IMM", "EXT", "BUS", "INT"
            GPIBwrite v_address, "TRIG:SOUR " + Trigger
        Case Else
            GPIBwrite v_address, "TRIG:SOUR IMM"
     End Select
End Sub


Public Sub hp33120BurstCount(burstcnt)
    GPIBwrite v_address, "BM:NCYCles " + Str$(burstcnt)
End Sub
' back compatibility command
Public Sub burstcnt(burstcnt)
    hp33120BurstCount burstcnt
End Sub
Public Sub BurstPhase(phase)
    GPIBwrite v_address, "BM:PHAS" + Str$(phase)
End Sub
Public Sub burstrate(burstrate)
    GPIBwrite v_address, "BM:INTernal:RATE " + Str$(burstrate)
End Sub
Public Sub BurstMode(OnOff As String)
    If OnOff = "ON" Then
        GPIBwrite v_address, "BM:STATe ON"
    Else
        GPIBwrite v_address, "BM:STATe OFF"
    End If
End Sub
Public Sub BURSTon()
    GPIBwrite v_address, "BM:stat ON"
End Sub

Public Sub BurstOff()
    GPIBwrite v_address, "BM:stat OFF"
End Sub

Public Property Let address(value)
       v_address = value
       gpibopen v_address
End Property

Public Property Get address()
       address = v_address
End Property


