VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "HP6624"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'******************************************************************
' ClassWork Library
' Released under OpenSource Policy
'
' Instrument : HP6624 Quad system Power supply
' Manufacturer : Hewlett packard
'
' Initial release   15/11/1999      V.Himpe
'******************************************************************

Private v_address  ' GPIB address for this device
Private v_entity   ' entity in multichannel devices

Public Sub Class_Initialize()
   logentry "'Classwork spawned a HP6624 instrument"
End Sub

Public Property Let Address(addr)
    v_address = addr
End Property

Public Property Let Assignto(channel As PSU_channel)
    v_entity = channel
End Property

Public Property Let voltage(level)
    Dta$ = "VSET" + sStr$(v_entity) + "," + Format$(level, "00.000")
    GPIBwrite v_address, Dta$
End Property
  
Public Property Let Current(level)
    Dta$ = "ISET" + sStr$(v_entity) + "," + Format$(level, "00.000")
    GPIBwrite v_address, Dta$
End Property
  
Public Property Let overload(level)
      Dta$ = "OVSET " + sStr$(v_entity) + "," + Format$(level, "00.000")
      GPIBwrite v_address, Dta$
End Property
  
Public Property Let output(state As Boolean)
    If OnOff = True Then
      GPIBwrite v_address, "OUT + Str$(v_entity) + ", "1"
      Else
      GPIBwrite v_address, "OUT + Str$(v_entity) + ", "0"
    End If
End Property
  
Public Property Get Current()
    GPIBread v_address, "IOUT? " + Str$(v_entity)
    Current = ibret
End Property

Public Property Get voltage()
    GPIBread v_address, "VOUT? " + Str$(v_entity)
    ReadVoltage = ibret
End Property

