VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "HP66311"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'******************************************************************
' ClassWork Library
' Released under OpenSource Policy
'
' Instrument : HP66311 Power supply
' Manufacturer : Hewlett packard
'
' Initial release   30/03/2000      V.Himpe
'******************************************************************

Private v_address  ' GPIB address for this device
Private v_entity   ' entity in multichannel devices

Public Sub Class_Initialize()
   logentry "'Classwork spawned a HP66311 instrument"
End Sub

Public Property Let Address(addr)
    v_address = addr
    GPIBopen v_address
    GPIBwrite v_address, "SENS:CURR:RANG 4"
    
End Property

Public Property Let Assignto(channel As CW_Channels)
    v_entity = channel
End Property

Public Property Let voltage(level)
      dta$ = "SOUR:VOLT " + Format$(level, "00.000")
      GPIBwrite v_address, dta$
End Property
Public Property Get voltage()
      GPIBread v_address, "MEAS:VOLT? "
      voltage = ibret
End Property
  
Public Property Let Current(level)
      dta$ = "SPIR:CURR " + Format$(level, "00.000")
      GPIBwrite v_address, dta$
End Property
Public Property Get Current()
      GPIBread v_address, "MEAS:CURR?"
      Current = ibret
End Property

Public Property Let OverVoltage(level)
      dta$ = "OVSET " + Format$(level, "00.000")
      GPIBwrite v_address, dta$
End Property
  
Public Property Let output(state As Boolean)
     If state = True Then
       GPIBwrite v_address, "OUTP:STAT 1"
       Else
       GPIBwrite v_address, "OUTP:STAT 0"
     End If
End Property




