VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "NGPS"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'******************************************************************
' ClassWork Library
' Released under OpenSource Policy
'
' Instrument : NGPS Voltage source
' Manufacturer : Rohde & Schwarz
'
' Initial release   15/11/1999      V.Himpe
'******************************************************************

Private v_address  ' GPIB address for this device
Private v_entity   ' entity in multichannel devices


Public Property Let Address(addr)
    v_address = addr
End Property

Public Property Let Assignto(channel)
    v_entity = channel
End Property
Public Sub Class_Initialize()
   logentry "'Classwork spawned a NGPS instrument"
End Sub


' ********************** Instrument functions **********************
Public Property Let voltage(level)
   Dim t$, sign$
   Select Case v_entity
      Case 2
         t$ = "UB"
      Case 999
         t$ = "UC"
      Case Else
         t$ = "UA"
   End Select
   If Abs(level) = level Then
      sign$ = "+"
      Else
      sign$ = "-"
   End If
   If Abs(level) < 16 Then
       GPIBwrite v_address, t$ + "L" + sign$ + LTrim$(Str$(level)) ' set voltage on ngps
   Else
       GPIBwrite v_address, t$ + "H" + sign$ + LTrim$(Str$(level)) ' set voltage on ngps
   End If
End Property
Public Property Let Current(level)

End Property

Public Property Let output(state As Boolean)

End Property

