VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "HP34401"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'******************************************************************
' ClassWork Library
' Released under OpenSource Policy
'
' Instrument : HP34401 System multimeter
' Manufacturer : Hewlett packard
'
' Initial release   15/11/1999      V.Himpe
'******************************************************************

Private v_address  ' GPIB address for this device
Private v_entity   ' entity in multichannel devices

Public Sub Class_Initialize()
   logentry "'Classwork spawned a HP34401 instrument"
End Sub

Public Property Let Address(addr)
    v_address = addr
    GPIBopen addr
End Property

Public Property Let Assignto(channel)
    v_entity = channel
End Property

Public Sub VoltsDc()
    GPIBwrite v_address, ":CONF:VOLT:DC"
End Sub

Public Sub VoltsAc()
    GPIBwrite v_address, ":CONF:VOLT:AC"
End Sub

Public Sub CurrentDC()
    GPIBwrite v_address, ":CONF:CURR:DC"
End Sub

Public Sub CurrentAC()
    GPIBwrite v_address, ":CONF:CURR:AC"
End Sub

Public Sub ohms4()
    GPIBwrite v_address, ":CONF:FRES"
End Sub

Public Sub Frequency()
    GPIBwrite v_address, ":CONF:FREQ"
End Sub

Public Sub Period()
    GPIBwrite v_address, ":CONF:PER"
End Sub

Public Sub ohms2()
    GPIBwrite v_address, ":CONF:RES"
End Sub
Public Sub Trigger(mode)
    Select Case mode
    Case 1     ' external ( vanachteren )
        GPIBwrite v_address, "TRIG:SOUR:IMM"
    Case Else  ' internal
        GPIBwrite v_address, "TRIG:SOUR:EXT"
    End Select
End Sub

Public Function measure()
    GPIBwrite v_address, "INIT"
    GPIBread v_address, "FETCH?"
    measure = ibret
    
End Function

