Attribute VB_Name = "hp33120a"
Option Explicit

' -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
'  Hewlett Packard 33120A
'  Arbitrary function Generator
' -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
'  Winvision  Instrument library
'  Initial release: 23/10/98
'  Written by : Vincent Himpe
'
'  Modification history :
'  Fixed HP impedance ( W.Declercq )
'  added burst control W.Declercq
'  added dcycle control M.Ohletz
'  Added trigger controls M.Ohletz
'
'  Revised By V.Himpe
'  30 / 08 / 1999 :  Verified for Winvision Release IV  V.Himpe
' -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

Public Sub hp33120impedance(address, impedance As String)
   Select Case impedance
   Case "50", "MIN", "MAX", "INF"
       GPIBwrite address, "OUTP:LOAD " +impedance
   Case Else
       GPIBwrite address, "OUTP:LOAD 50"
   End Select
End Sub
Public Sub HP33120frequency(address, frequency)
    GPIBwrite address, "SOUR:FREQ " + Str$(frequency)
End Sub
Public Sub HP33120Amplitude(address, amplitude)
    GPIBwrite address, "SOUR:VOLT " + Str$(amplitude)
End Sub
Public Sub HP33120Offset(address, offset)
    GPIBwrite address, "SOUR:VOLT:OFFS " + Str$(offset)
End Sub
Public Sub HP33120Sine(address)
    GPIBwrite address, "SOUR:FUNC:SHAP SIN"
End Sub
Public Sub HP33120Ramp(address)
    GPIBwrite address, "SOUR:FUNC:SHAP RAMP"
End Sub
Public Sub HP33120triangle(address)
    GPIBwrite address, "SOUR:FUNC:SHAP TRI"
End Sub
Public Sub HP33120Square(address)
    GPIBwrite address, "SOUR:FUNC:SHAP SQU"
End Sub
Public Sub HP33120Noise(address)
    GPIBwrite address, "SOUR:FUNC:SHAP NOIS"
End Sub
Public Sub HP33120DC(address)
    GPIBwrite address, "SOUR:FUNC:SHAP DC"
End Sub
Public sub hp33120Pulse(address)
    GPIBwrite address, "SOUR:FUNC:SHAP PULS"
end sub
Public Sub HP33120PDCycle(address, duty_cycle)
    GPIBwrite address, "SOUR:PULS:DCYC" + Str$(duty_cycle)
End Sub
Public Sub HP33120TriggerNOW(address)
    GPIBwrite address, "*TRG"
    GPIBwrite address, "*WAI"
End Sub
Public Sub HP33120TriggerInt(address)
    GPIBwrite address, "TRIGGER:SOURCE int"
End Sub
Public Sub HP33120TriggerBus(address)
    GPIBwrite address, "TRIGGER:SOURCE bus"
End Sub
Public Sub HP33120TriggerExt(address)
    GPIBwrite address, "TRIGGER:SOURCE EXT"
End Sub
Public Sub HP33120Arb(address)
    GPIBwrite address, "FUNC:USER VOLATILE"
    GPIBwrite address, "FUNC:SHAP USER"
End Sub

Public Sub HP33120LoadArb(address, wavefile As String)
    Dim filehandle
    Dim cmd$
    Dim a$
    On Error GoTo skipfile
    filehandle = FreeFile
    cmd$ = "DATA VOLATILE"
    Open wavefile For Input As filehandle
    While Not EOF(filehandle)
       Line Input #1, a$
       cmd$ = cmd$ + "," + Trim$(a$)
    Wend
    GPIBwrite address, cmd$
skipfile:
    Close filehandle
End Sub
Public Sub hp33120Sweep(address, startfreq, stopfreq, sweeptime, linlog)
    GPIBwrite address, "SOUR:FREQ:STAR " + Str$(startfreq)
    GPIBwrite address, "SOUR:FREQ:STOP " + Str$(stopfreq)
    GPIBwrite address, "SOUR:SWE:TIME " + Str$(sweeptime)
    If linlog = 0 Then
       GPIBwrite address, "SOUR:SWE:SPAC LIN"
    Else
       GPIBwrite address, "SOUR:SWE:SPAC LOG"
    End If
End Sub
Public Sub hp33120StartSweep(address)
    GPIBwrite address, "SOUR:SWE:STAT ON"
End Sub
Public Sub hp33120StopSweep(address)
    GPIBwrite address, "SOUR:SWE:STAT OFF"
End Sub
Public Sub hp33120trig(address, trigger As String)
     Select Case trigger
        Case "IMM", "EXT", "BUS","INT"
            GPIBwrite address, "TRIG:SOUR " + trigger
        Case Else
            GPIBwrite address, "TRIG:SOUR IMM"
     End Select
End Sub


Public Sub hp33120BurstCount(address, burstcnt)
    GPIBwrite address, "BM:NCYCles " + Str$(burstcnt)
End Sub
' back compatibility command
Public Sub hp33120BurstCnt(address, burstcnt)
    hp33120burstcount address,burstcnt
End sub
Public sub hp33120BurstPhase (address,phase)
    gpibwrite address,"BM:PHAS"+str$(phase)
end sub
Public Sub hp33120BurstRate(address, burstrate)
    GPIBwrite address, "BM:INTernal:RATE " + Str$(burstrate)
End Sub
Public Sub hp33120BurstMode(address, onOff As String)
    If onOff = "ON" Then
        GPIBwrite address, "BM:STATe ON"
    Else
        GPIBwrite address, "BM:STATe OFF"
    End If
End Sub
Public Sub HP33120BURSTon(address)
    GPIBwrite address, "BM:stat ON"
End Sub

Public Sub HP33120BurstOff(address)
    GPIBwrite address, "BM:stat OFF"
End Sub
