Attribute VB_Name = "hp3336c"
Option Explicit

' -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
'  Hewlett Packard 3336c
'  Synthesizer level generator
' -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
'  Winvision  Instrument library
'  Initial release: 23/10/98
'  Written by : Vincent Himpe
'
'  Modification history :
'  30 / 08 / 1999 :  Verified for Winvision Release IV  V.Himpe
' -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

Public Sub HP3336frequency(address, frequency)
    GPIBwrite address, "FR" + Trim$(Str$(frequency)) + "HZ"
End Sub
Public Sub HP3336terminate(address, termination)
    Select Case termination
    Case 75
       GPIBwrite address, "OI2"
    Case Else
       GPIBwrite address, "OI1"
    End Select
End Sub
Public Sub HP3336level(address, level)
   GPIBwrite address, "AM" + Trim$(Str$(level)) + "DB"
End Sub
Public Sub HP3336phase(address, phase)
   GPIBwrite address, "PH" + Trim$(Str$(phase)) + "DE"
End Sub
Public Sub HP3336sweep(address, startfreq, stopfreq, sweeptime, logsweep)
   GPIBwrite address, "ST" + Trim$(Str$(startfreq)) + "HZ"
   GPIBwrite address, "SP" + Trim$(Str$(stopfreq)) + "HZ"
   GPIBwrite address, "TI" + Trim$(Str$(sweeptime)) + "SE"
   If logsweep = 1 Then
      GPIBwrite address, "SM2"
   Else
      GPIBwrite address, "SM1"
   End If
      GPIBwrite address, "SC"
End Sub
Public Sub HP3336marker(address, markerfreq)
   GPIBwrite address, "MF" + Trim$(Str$(markerfreq)) + "HZ"
End Sub
