Attribute VB_Name = "hp3585"

' -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
'  Hewlett Packard 3585
'  Spectrum analyser
' -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
'  Winvision  Instrument library
'  Initial release: --/--/--
'  Written by : Vincent Teil. Updated by V.Himpe
'
'  Modification history :
' -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-


Sub hp3585fcenter(address, frequency)
    GPIBwrite address, "CF" + Str$(frequency) + " HZ"
End Sub
Sub hp3585fspan(address, frequency)
    GPIBwrite address, "FS" + Str$(frequency) + " HZ"
End Sub
Sub hp3585fstart(address, frequency)
    GPIBwrite address, "FA" + Str$(frequency) + " HZ"
End Sub
Sub hp3585fstop(address, frequency)
    GPIBwrite address, "FB" + Str$(frequency) + " HZ"
End Sub
Sub hp3585reflevel(address, frequency)
    GPIBwrite address, "RL" + Str$(frequency) + " HZ"
End Sub
Sub hp3585sweeptime(address, sweeptime)
    GPIBwrite address, "ST" + Str$(sweeptime) + " SC"
End Sub
Sub hp3585RBW(address, RBW) ' resolution BandWidth
    GPIBwrite address, "RB" + Str$(RBW) + " HZ"
End Sub
Sub hp3585VBW(address, VBW) ' video BandWidth
    GPIBwrite address, "VB" + Str$(VBW) + " HZ"
End Sub

Sub hp3585saveA(address)
    GPIBwrite address, "TS"
End Sub
Sub hp3585recallA(address)
    GPIBwrite address, "TR"
End Sub
Sub hp3585AutoCalibrate(address, state As Boolean)
    If state = True Then
      GPIBwrite address, "AC 1"
     Else
      GPIBwrite address, "AC 0"
    End If
End Sub
Sub hp3585SingleSweep(address)
    GPIBwrite address, "S2"
End Sub
Sub hp3585ContinuousSweep(address)
    GPIBwrite address, "S1"
End Sub
Sub hp3585TriggerInt(address)
    GPIBwrite address, "T1"
End Sub
Sub hp3585TriggerEXT(address)
    GPIBwrite address, "T3"
End Sub
Sub hp3585Impedance(address, impedance)
    Select Case impedance
    Case 50
       GPIBwrite address, "I2"
    Case 75
       GPIBwrite address, "I3"
    Case Else
       GPIBwrite address, "I1"
    End Select
End Sub

Function hp3585getstatus(address)
    GPIBread address, "D7,T4"
    hp3585getstatus = ib$
End Function
Sub hp3585waitsweepcomplete(address)
  Do
     GPIBread address, "D0,T4"
     sweepfinished = Asc(ib$)
     sweepfinished = sweepfinished And 128
    Loop Until (sweepfinished = 0)
    
End Sub

Sub hp3585getcurve(address, ByRef datagrid(), ByRef header$)
        
    GPIBtimeout 100, address
    GPIBwrite address, "S2,T4" 'single sweep (problem if continuous sweep)
    'GPIBwrite address, "SA"
    'Pause 10
    
    hp3585waitsweepcomplete address
    
    ib$ = "" 'reinitializes ib$
    GPIBread address, "D3,T4"
        
    pntr = 2
    vmax = -100
    vmin = 0
    ib$ = ib$ + "'"
    While (Len(ib$) > 0) And (pntr < 1002) 'looks for the 1001 points
     x$ = Left$(ib$, InStr(ib$, ","))
     ib$ = Right$(ib$, Len(ib$) - Len(x$) - 1)
     datagrid(pntr) = Val(x$)
     If datagrid(pntr) > vmax Then vmax = datagrid(pntr)
     If datagrid(pntr) < vmin Then vmin = datagrid(pntr)
     pntr = pntr + 1
     t = t + 1
    Wend
    datagrid(0) = vmin
    datagrid(1) = vmax
    
    GPIBread address, "D7,T4"
    header$ = ib$
    
    GPIBtimeout 10, address
End Sub
Sub hp3585test(address, ByRef datagrid(), ByRef header$)
    Dim pntr, yy, yyy, xxx, x As Integer
    GPIBwrite address, "SA" ' store a register
    GPIBwrite address, "TS 0" ' save live data to register 1
    GPIBread address, "BD 0" ' Retrieve register 1
    pntr = 1
    For x = 1 To Len(ib$) Step 2
        yy = Asc(Mid$(ib$, x, 1))
        yyy = Asc(Mid$(ib$, x + 1, 1))
        xxx = (yy * 256) + yyy
        If xxx And &H8000 = &H8000 Then
           xxx = 0 - (65535 - xxx)
        End If
        datagrid(pntr) = (xxx / 100)
        pntr = pntr + 1
    Next x
    GPIBread address, "D7,T4"
    header$ = ib$
    
End Sub


Sub hp3585ref(address, level)
     GPIBwrite address, "RL" + Str$(level) + " DM"
End Sub

Sub hp3585range(address, level)
    Select Case level
    Case 30
        GPIBwrite address, "R12"
    Case 25
        GPIBwrite address, "R11"
    Case 20
        GPIBwrite address, "R10"
    Case 15
        GPIBwrite address, "R09"
    Case 10
        GPIBwrite address, "R08"
    Case 5
        GPIBwrite address, "R07"
    Case 0
        GPIBwrite address, "R06"
    End Select
End Sub

