Attribute VB_Name = "kth2400"
' -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
'  Keithley 2400
'  Source measure unit
'  Winvision  Instrument library
'  Initial release: 09/06/99
'  Written by : Bert Vercauteren
'
'  Modification history :
'  30 / 08 / 1999 :  Verified for Winvision Release IV  V.Himpe
'  24/02 /2000 : Fixed Sourcecurrent . Is autoranging now
' -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

Public Sub kth2400Sourcevoltage(address, voltage)

     

        GPIBwrite address, ":SOUR:VOLT:LEV:IMM:AMPL " + LTrim$(Str$(voltage))
End Sub

Public Sub kth2400SourceCurrent(address, current)
   
   
   ' you can't use select case here because select case cannot handle floats !
   ' scans for optimum range and then sets machine to that range
   
   
   If Abs(current) <> current Then sign = -1 Else sign = 1
   
   If Abs(current) <= 1 Then
      curr = "1"
   End If
   If Abs(current) <= 0.1 Then
      curr = "100E-3"
   End If
   If Abs(current) <= 0.01 Then
      curr = "10E-3"
   End If
   If Abs(current) <= 0.001 Then
      curr = "1E-3"
   End If
   If Abs(current) <= 0.0001 Then
      curr = "100E-6"
   End If
   If Abs(current) <= 0.00001 Then
      curr = "10E-6"
   End If
   If Abs(current) <= 0.000001 Then
      curr = "1E-6"
   End If
   
   GPIBwrite address, ":SOUR:CURR:RANG " & curr * sign
   GPIBwrite address, ":SOUR:CURR:LEV:IMM:AMPL " + LTrim$(Str$(current))
    
End Sub

Public Sub KTH2400CurrentCompliance(address, current)
End Sub

Public Sub KTH2400VoltageCompliance(address, voltage)


End Sub
    
Public Function kth2400MeasureVoltage(address)

    GPIBread address, "VOLT:DC:AUTO 1"
        
End Function

Public Function kth2400MeasureCurrent(address)

    

End Function

Public Function kth2400MeasureOhms(address)



End Function

Public Function kth2400Measure(address)



End Function

Public Sub KTH2400Output(address, onoff As Boolean)
    If onoff = True Then
        GPIBwrite address, ":OUTPUT:STATE 1"
      Else
        GPIBwrite address, ":OUTPUT:STATE 0"
    End If
End Sub

