Attribute VB_Name = "NRVD"
' ****************************************************************
' NRVZ power meter library
' Vincent Himpe 03/08/1999
' ****************************************************************

Sub NRVDreferenceOFF(address)
GPIBwrite address, "OUTP:ROSZ OFF"
End Sub
Sub NRVDreferenceON(address)
GPIBwrite address, "OUTP:ROSZ ON"
End Sub
Function NRVDforward(address)
     GPIBwrite address, "INP:NSEL 1"
     GPIBread address, "*TRG"
     NRVDforward = ibret
End Function
Function NRVDreverse(address)
     GPIBwrite address, "INP:NSEL 2"
     GPIBread address, "*TRG"
     NRVDreverse = ibret
End Function

Sub NRVDinit(address)
    ' set to dual channel mode
    GPIBwrite address, "DISP:ANN:AMPL DUAL"
    
    ' both channels in power mode
    GPIBwrite address, "INP:NSEL 1"
    GPIBwrite address, "FUNC " + vbQuote + "POW:AC" + vbQuote
    GPIBwrite address, "INP:NSEL 2"
    GPIBwrite address, "FUNC " + vbQuote + "POW:AC" + vbQuote
    
    ' enter offset for both channels to compensate coupler
    GPIBwrite address, "INP:NSEL 1"
    GPIBwrite address, "AMPL:ATT 40" ' 40 db correction
    GPIBwrite address, "INP:NSEL 2"
    GPIBwrite address, "AMPL:ATT 40" ' 40 db correction
    
    ' set both channels to watt reading
    GPIBwrite address, "INP:NSEL 1"
    GPIBwrite address, "AMPL:UNIT W"
    GPIBwrite address, "INP:NSEL 2"
    GPIBwrite address, "AMPL:UNIT W"
    
End Sub

