Attribute VB_Name = "WG_ILS1"

' -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
' WinVision Control library
' Written by W.Declercq
' Modification history
'  30 / 08 / 1999 :  Verified for Winvision Release IV  V.Himpe
' -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

Const delaywriteGpib = 3

Const WGILS1_PTP = 7
Const WGILS1_SPB1 = 8
Const WGILS1_bal = 9
Const WGILS1_sinus = 10
Const WGILS1_kHz200 = 11
Const WGILS1_noRes = 12
Const WGILS1_te2nt = 13

Public Sub ILS1mode(address, mode)
    If mode = WGILS1_PTP Then
        GPIBwrite address, "MODE PTP,"
    Else
        GPIBwrite address, "MODE SPB1,"
    End If
    delay delaywriteGpib
End Sub

Public Sub ILS1coupling(address, coupling)
    If coupling = WGILS1_bal Then
        GPIBwrite address, "NG_COUPLE BAL,"
    Else
        GPIBwrite address, "NG_COUPLE COM,"
    End If
    delay delaywriteGpib
End Sub

Public Sub ILS1noiseMode(address, noiseMode)
    If noiseMode = WGILS1_sinus Then
        GPIBwrite address, "NG_MODE SS,"
    Else
        GPIBwrite address, "NG_MODE OFF,"
    End If
    delay delaywriteGpib
End Sub

Public Sub ILS1noiseVoltage(address, noiseVoltage)
    GPIBwrite address, "NG_SS_BAL " + Trim$(Str$(noiseVoltage)) + ","
    delay delaywriteGpib
End Sub

Public Sub ILS1noiseFrequency(address, noiseFrequency)
    If noiseFrequency = WGILS1_kHz200 Then
        GPIBwrite address, "NG_SS_FREQ 200K,"
    Else
        GPIBwrite address, "NG_SS_FREQ 2M,"
    End If
    delay delaywriteGpib
End Sub

Public Sub ILS1termResistors(address, mode, resistors)
    If mode = WGILS1_PTP Then
        If resistors = WGILS1_noRes Then
            GPIBwrite address, "TR 1 PTP OFF,"
            delay delaywriteGpib
            GPIBwrite address, "TR 2 PTP OFF,"
        Else
            GPIBwrite address, "TR 1 PTP ON,"
            delay delaywriteGpib
            GPIBwrite address, "TR 2 PTP ON,"
        End If
    Else
        If resistors = WGILS1_noRes Then
            GPIBwrite address, "TR 1 SPB1 OFF,"
            delay delaywriteGpib
            GPIBwrite address, "TR 2 SPB1 OFF,"
        Else
            GPIBwrite address, "TR 1 SPB1 ON,"
            delay delaywriteGpib
            GPIBwrite address, "TR 2 SPB1 ON,"
        End If
    End If
    delay delaywriteGpib
End Sub

Public Sub ILS1direction(address, mode, direction)
    If mode = WGILS1_PTP Then
        If direction = WGILS1_te2nt Then
            GPIBwrite address, "NG_SW_DIR 1 TE PTP,"
            delay delaywriteGpib
            GPIBwrite address, "NG_SW_DIR 2 TE PTP,"
        Else
            GPIBwrite address, "NG_SW_DIR 1 NT PTP,"
            delay delaywriteGpib
            GPIBwrite address, "NG_SW_DIR 2 NT PTP,"
        End If
    Else
        If direction = WGILS1_te2nt Then
            GPIBwrite address, "NG_SW_DIR 1 TE SPB1,"
            delay delaywriteGpib
            GPIBwrite address, "NG_SW_DIR 2 TE SPB1,"
        Else
            GPIBwrite address, "NG_SW_DIR 1 NT SPB1,"
            delay delaywriteGpib
            GPIBwrite address, "NG_SW_DIR 2 NT SPB1,"
        End If
    End If
    delay delaywriteGpib
End Sub

Public Sub ILS1lineLength(address, mode, length)
    If mode = WGILS1_PTP Then
        GPIBwrite address, "LINE 1 PTP " + Trim$(Str$(length)) + ","
    Else
        GPIBwrite address, "LINE 1 SPB1 " + Trim$(Str$(length)) + ","
    End If
End Sub
