Attribute VB_Name = "WG_ILS2"
Option Explicit
' -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
' Wandel en Goltermann ILS -2
'
' WinVision control library
' (c) 1998 V.Himpe
' Modification History
'  30 / 08 / 1999 :  Verified for Winvision Release IV  V.Himpe
' -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
Const delaywriteGpib = 5

Const WGILS2_toA = 3
Const WGILS2_toB = 5
Const WGILS2_none = 4
Const WGILS2_intBal = 5
Const WGILS2_ETR080 = 6
Const WGILS2_IMP = 7
Const WGILS2_commonMode = 8
Const WGILS2_TRI = 9
Const WGILS2_toMid = 10

Public Sub ILS2etsi(address, mode)
    delay delaywriteGpib
    GPIBThunkOut address, "MODE ETSI" + Trim$(Str$(mode)) + ","
    delay delaywriteGpib
End Sub

Public Sub ILS2db(address, mode, level, noUnits)
    delay delaywriteGpib
    If noUnits = True Then
      GPIBThunkOut address, "X_VALUE ETSI" + Trim$(Str$(mode)) + ","
    Else
      GPIBThunkOut address, "X_VALUE ETSI" + Trim$(Str$(mode)) + " " + Trim$(Str$(level)) + ","
    End If
    delay delaywriteGpib
End Sub
Public Sub ILS2coupling(address, direction)
    delay delaywriteGpib
    If direction = 1 Then
       GPIBThunkOut address, "AB_COUPLE A_TO_B,"
    Else
       GPIBThunkOut address, "AB_COUPLE B_TO_A,"
    End If
    delay delaywriteGpib
End Sub
Public Sub ILS2noiseSetBal(address, noiseLevel)
    delay delaywriteGpib
    If noiseLevel = 25 Then
        GPIBThunkOut address, "NG_BAL_ETSI_300 8.9,"
    Else
        If noiseLevel = 105 Then
            GPIBThunkOut address, "NG_BAL_ETSI_300 22.4,"
        Else
            If noiseLevel = 0 Then
                GPIBThunkOut address, "NG_BAL_ETSI_300 6.7,"
            End If
        End If
    End If
    delay delaywriteGpib
End Sub

Public Sub ILS2noiseSetImp(address)
    delay delaywriteGpib
    GPIBThunkOut address, "NG_BAL_IMP 100 50 0 50 2,"
    delay delaywriteGpib
End Sub

Public Sub ILS2noiseBalMode(address, noiseBalMode)
    delay delaywriteGpib
    If noiseBalMode = WGILS2_ETR080 Then
        GPIBThunkOut address, "NG_BAL_MODE ETSI_300,"
    Else
        If noiseBalMode = WGILS2_IMP Then
            GPIBThunkOut address, "NG_BAL_MODE IMP,"
        End If
    End If
    delay delaywriteGpib
End Sub

Public Sub ILS2noiseComMode(address, noiseComMode)
    delay delaywriteGpib
    If noiseComMode = WGILS2_TRI Then
        GPIBThunkOut address, "NG_COM_MODE TRI,"
    End If
    delay delaywriteGpib
End Sub

Public Sub ILS2noiseComTri(address)
    delay delaywriteGpib
    GPIBThunkOut address, "NG_COM_TRI 50 25,"
    delay delaywriteGpib
End Sub

Public Sub ILS2noiseCoupling(address, noiseCoupling)
    delay delaywriteGpib
    If noiseCoupling = WGILS2_intBal Then
        GPIBThunkOut address, "NG_COUPLE BAL_INT,"
    Else
        If noiseCoupling = WGILS2_commonMode Then
            GPIBThunkOut address, "NG_COUPLE COM_INT,"
        End If
    End If
    delay delaywriteGpib
End Sub

Public Sub ILS2BalSwitch(address, noiseSwitch)
    delay delaywriteGpib
    If noiseSwitch = WGILS2_toA Then
        GPIBThunkOut address, "NG_BAL_SWITCH A,"
    Else
        If noiseSwitch = WGILS2_toB Then
            GPIBThunkOut address, "NG_BAL_SWITCH B,"
        Else
            GPIBThunkOut address, "NG_BAL_SWITCH NONE,"
        End If
    End If
    delay delaywriteGpib
End Sub

Public Sub ILS2ComSwitch(address, noiseSwitch)
    delay delaywriteGpib
    If noiseSwitch = WGILS2_toMid Then
        GPIBThunkOut address, "NG_COM_SWITCH MID,"
    End If
    delay delaywriteGpib
End Sub

