Attribute VB_Name = "DS345"
' -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
'  Stanford research
'  DS345 Synthesized function generator
'  Winvision  Instrument library
'  Initial release: 09/06/99
'  Written by : Vincent Himpe
' -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-



Public Sub DS345frequency(address, frequency)
    GPIBwrite address, "FREQ " + Str$(frequency)
End Sub
Public Sub DS345amplitude(address, amplitude)
    GPIBwrite address, "AMPL " + Str$(amplitude) + " VP"
End Sub
Public Sub DS345offset(address, offset)
    GPIBwrite address, "OFFS " + Str$(offset)
End Sub

Public Sub DS345Sine(address)
    GPIBwrite address, "FUNC 0"
End Sub
Public Sub DS345Ramp(address)
    GPIBwrite address, "FUNC 3"
End Sub
Public Sub DS345Triangle(address)
    GPIBwrite address, "FUNC 2"
End Sub
Public Sub DS345Square(address)
    GPIBwrite address, "FUNC 1"
End Sub
Public Sub DS345Noise(address)
    GPIBwrite address, "FUNC 4"
End Sub
Public Sub DS345ARB(address)
    GPIBwrite address, "FUNC 5"
End Sub
Public Sub DS345Invert(address, state As Boolean)
    If state = True Then
    GPIBwrite address, "INVT 1 " + sStr$(count)
    Else
    GPIBwrite address, "INVT 0 " + sStr$(count)
    End If
End Sub
Public Sub DS345BurstCount(address, count)
    GPIBwrite address, "BCNT " + sStr$(count)
End Sub
Public Sub DS345AMdepth(address, depth)
    GPIBwrite address, "DPTH " + sStr$(depth)
End Sub
Public Sub DS345FMdeviation(address, deviation)
    GPIBwrite address, "FDEV " + sStr$(deviation)
End Sub

Public Sub DS345MODSine(address)
    GPIBwrite address, "MDWF 3"
End Sub
Public Sub DS345MODRamp(address)
    GPIBwrite address, "MDWF 1"
End Sub
Public Sub DS345MODTriangle(address)
    GPIBwrite address, "MDWF 2"
End Sub
Public Sub DS345MODSquare(address)
    GPIBwrite address, "MDWF 4"
End Sub
Public Sub DS345MODoff(address)
    GPIBwrite address, "FUNC 6"
End Sub
Public Sub DS345MODARB(address)
    GPIBwrite address, "MDWF 5"
End Sub
Public Sub DS345MODsingle(address)
    GPIBwrite address, "MDWF 0"
End Sub
Public Sub DS345Modulation(address, state As Boolean)
     If state = True Then
        GPIBwrite address, "MENA 1"
       Else
        GPIBwrite address, "MENA 1"
     End If
End Sub










Public Sub sweep(address, startfreq, stopfreq, sweeptime, linlog)
    GPIBwrite address, "SOUR:FREQ:STAR " + Str$(startfreq)
    GPIBwrite address, "SOUR:FREQ:STOP " + Str$(stopfreq)
    GPIBwrite address, "SOUR:SWE:TIME " + Str$(sweeptime)
    If linlog = 0 Then
       GPIBwrite address, "SOUR:SWE:SPAC LIN"
    Else
       GPIBwrite address, "SOUR:SWE:SPAC LOG"
    End If
End Sub
Public Sub StartSweep(address)
    GPIBwrite address, "SOUR:SWE:STAT ON"
End Sub
Public Sub StopSweep(address)
    GPIBwrite address, "SOUR:SWE:STAT OFF"
End Sub
Public Sub trig(addressTrigger As String)
     Select Case Trigger
        Case "IMM", "EXT", "BUS", "INT"
            GPIBwrite address, "TRIG:SOUR " + Trigger
        Case Else
            GPIBwrite address, "TRIG:SOUR IMM"
     End Select
End Sub


Public Sub hp33120BurstCount(address, burstcnt)
    GPIBwrite address, "BM:NCYCles " + Str$(burstcnt)
End Sub
' back compatibility command
Public Sub burstcnt(address, burstcnt)
    hp33120BurstCount address, burstcnt
End Sub
Public Sub BurstPhase(address, phase)
    GPIBwrite address, "BM:PHAS" + Str$(phase)
End Sub
Public Sub burstrate(address, burstrate)
    GPIBwrite address, "BM:INTernal:RATE " + Str$(burstrate)
End Sub
Public Sub BurstMode(address, onoff As String)
    If onoff = "ON" Then
        GPIBwrite address, "BM:STATe ON"
    Else
        GPIBwrite address, "BM:STATe OFF"
    End If
End Sub
Public Sub BURSTon(address)
    GPIBwrite address, "BM:stat ON"
End Sub

Public Sub BurstOff(address)
    GPIBwrite address, "BM:stat OFF"
End Sub
Public Sub impedance(address, impedance As Integer)
   Select Case impedance
   Case Minimum
       GPIBwrite address, "OUTP:LOAD MIN"
   Case Maximum
       GPIBwrite address, "OUTP:LOAD MAX"
   Case Infinite
       GPIBwrite address, "OUTP:LOAD INF"
   Case Else
       GPIBwrite address, "OUTP:LOAD 50"
   End Select
End Sub




